unit Unit1;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, Forms, Controls, Graphics, Dialogs, StdCtrls, Printers,
  PrintersDlgs;

type

  { TForm1 }

  TForm1 = class(TForm)
    Button1: TButton;
    PrintDialog1: TPrintDialog;
    procedure Button1Click(Sender: TObject);
  private

  public

  end;

var
  Form1: TForm1;

implementation

{$R *.lfm}

{ TForm1 }


function mm2pix(mm:Double):Integer;
begin
  result:=round(mm * printer.XDPI / 25.4);
end;

procedure TForm1.Button1Click(Sender: TObject);
var count,x,y:Integer;
var xStep_mm:Double = 5.0;
var yStep_mm:Double = 5.0;

begin
  if NOT Printdialog1.execute then exit;

  Printer.Title:='Test';
  Printer.BeginDoc;       // Druckjob starten

  with printer.canvas do begin

    // den Stift einstellen
    Pen.Width:=0;                   // 0 oder 1 das scheint eagl zu sein
    Pen.Color:=clBlack;

    // den Pinsel einstellen
    Brush.Color:=clWhite;
    Brush.Style:=bsClear;

    // horizontale Rasterlinien zeichnen
    count:=0;
    x:=0;
    while x < Printer.PageWidth do begin
      x:=mm2pix(xStep_mm * count);
      inc(count);
      MoveTo(x,0);
      LineTo(x,Printer.PageHeight);
    end;

    // vertikale Rasterlinien zeichnen
    count:=0;
    y:=0;
    while y < Printer.PageHeight do begin
      y:=mm2pix(yStep_mm * count);
      inc(count);
      MoveTo(0,y);
      LineTo(Printer.PageHeight,y);
    end;

    // hier wird der Pen (die Linien) plötzlich breiter ??????
    Ellipse  (mm2pix(50),mm2pix(50),mm2pix(100),mm2pix(100));
    Rectangle(mm2pix(50),mm2pix(50),mm2pix(100),mm2pix(100));
  end;

  Printer.EndDoc;   // Druckjob beenden
end;

end.

